Search.additionalData = [
["Pages/Page_79038929.html","1. はじめに",
"1. はじめに\n 本ドキュメントには、 NEX を使用したアプリケーションの企画や開発を行う場合に有用な情報を記載しています。\n NEX プログラミングマニュアルでは、NEX が用意している各機能の説明を行っていますが、各機能の組み合わせによってどのような機能が実現できるのかといった情報や、機能を実装する場合に気を付ける必要のある情報、運用上の情報等記載できなかった項目があります。本ドキュメントにはプログラミングマニュアルを補足する内容を記載してあります。\n また、プログラミングマニュアルと違い、アプリケーションの企画者に向けた情報も掲載しています。\n",0]
,["Pages/Page_79040839.html","2. 開発・運用の流れ",
"2. 開発・運用の流れ\nNEX はサーバー機能とクライアントの組み合わせで使用します。このため、NEX を使用して開発を行う場合には開発・運用を合わせて考える必要があります。\nここでは、NEX を使用したアプリケーションを開発するためのフローについて説明します。\nNEX を使用した開発では、大きく分けて以下の 6 つのフェーズを意識する必要があります。\n \t企画検討 \t開発・デバッグ \tロットチェック \tサービスイン \tパッチのリリース \tローカライズ版の開発\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_企画検討","企画検討",
"企画検討\n企画検討のフェーズは、考えている企画を実現するために NEX を使用することができるか、また、どのように使用していけばよいかを考えるフェーズです。このフェーズでは未だタイトル用のゲームサーバーは用意されていません。このフェーズではサンプルデモサーバーを使用することになります。NEX のパッケージに含まれているサンプルプログラムの接続先がサンプルデモサーバーです。企画検討のための確認として NEX の各機能を使用する場合は、このサンプルデモサーバーを使用してください。\nこのサンプルデモサーバーは他の開発者と共有ですので、タイトル固有の秘密にすべき情報、他のタイトルに迷惑をかけるような行為については行わないでください。以下に注意すべき項目を挙げます。\n \tデータストアに、タイトル固有の情報をアップロードしない。画面キャプチャなどもアップロードしない \tランキングの共通データ等に、タイトル固有の情報を格納しない \tマッチメイクのゲームモードに、サンプルプログラムと同一のゲームモードを指定しない \t連続で API を呼び続ける等、ガイドラインの API アクセス回数制限を大幅に超えるような実装はしない \t自分が作成したデータ以外のデータをむやみに削除しない \tアプリの開発フェーズでは使用しない\nNEX のサンプルプログラムをそのまま実行する場合には特に制限はありません。\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_開発・デバッグ","開発・デバッグ",
"開発・デバッグ\n開発・デバッグフェーズは、企画検討が終わり、NEX を使用する方向性が固まったタイミングで開始されます。このフェーズではサンプルデモサーバーではなく、各タイトル毎に用意されたゲームサーバーを使用します。\nタイトル毎のゲームサーバーを使用するためには、OMAS から NEX の利用申請を行う必要があります。申請方法については各窓口にお問い合わせください。\nNEX の利用申請時には、どのように NEX の機能を使用するのかという情報が必要になります。詳細が決まっていない場合であってもゲームサーバーの準備は可能ですので、詳細は検討中という形で NEX の利用申請をしてください。この場合、企画が固まり次第申請内容の更新をお願いします。適切に申請されていない場合、テクニカルサポート、ロットチェック等がスムーズに進まない可能性があります。\nゲームサーバーが設置されると、OMAS からゲームサーバーのゲームサーバー ID とアクセスキーが確認できるようになります。こちらの情報を使用して各タイトル毎に用意されたゲームサーバーに接続してください。\nタイトル毎のゲームサーバーは、他のタイトルからは特別な設定を行わない限り参照できませんが、物理サーバーはタイトル毎に独立しておらず相乗りしている状態ですので、高負荷をかけ続けるような運用は避けてください。\n以下に注意すべき項目を挙げます\n \t連続で API を呼び続ける等、ガイドラインの NEX API 呼び出し頻度制限を大幅に超え続けるような実装はしない。\n※ 実験中に、一時的（数分程度）に過負荷がかかるような場合についてはこの限りではありません。\nNEX ライブラリのバージョンを変更する場合、ゲームサーバーのバージョンを事前に上げておく必要があります。OMAS 申請で、NEX のバージョンを変更すると、承認後にゲームサーバー更新が実施されます。更新される時期は、承認後 3 営業日以内です。\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_ロットチェック","ロットチェック",
"ロットチェック\nロットチェックを開始するためには、ロットチェックで使用するゲームサーバーが設置されている必要があります。ロットチェックで使用するサーバーが設置されるためには、OMAS のフェーズが「開発中/ロットチェック受付」まで進んでいる必要があります。\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_サービスイン","サービスイン",
"サービスイン\nロットチェックが完了すると、製品用のゲームサーバーが設置されます。製品用ゲームサーバーは、設置した時点から接続可能で、発売日とは連動していません。発売日前であっても製品用ゲームサーバーに接続することができます。発売日以降でなければ正常に動作しない仕様の場合には注意してください。\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_パッチのリリース","パッチのリリース",
"パッチのリリース\nパッチをリリースする場合には、パッチ適用前の ROM との間に通信互換性があるかどうかに注意してください。通信互換性が無い場合には、パッチ適用前の ROM がゲームサーバーに接続されないように、サーバー側の設定を行う必要がありますので、OMAS 申請時に「更新データ未適用時のネットワーク利用規制」と「更新データリリース時のNEXサーバ再起動」を「必要」と申請してください。\nパッチリリース時に NEX のバージョンを上げる必要がある場合、ゲームサーバーのバージョンも同時に上げる必要がありますので、この場合にも、パッチ適用前の ROM がゲームサーバーに接続されないようにする必要があります。\n",0]
,["Pages/Page_79040839.html#Anchor_79040839_ローカライズ版の開発","ローカライズ版の開発",
"ローカライズ版の開発\n既にリリース済みのタイトルのローカライズ版をリリースする場合、特別な理由が無い限りゲームサーバーを共用します。マッチメイクの結果や、データストアのデータ、ランキングデータを各リージョン毎に分けたい場合等はカテゴリやゲームモードを分けることで対応してください。この目的でゲームサーバーをリージョン毎に分けることはできません。\nローカライズ版でパッチをリリースする場合には通信互換性や NEX バージョンの変更には注意が必要です。通信互換性を切る場合、ゲームサーバーは各リージョンで共通ですので、全リージョンのパッチを同時にリリースする必要があります。このような仕様を考えている場合には、事前にパッチのリリース担当者と相談し、可否について確認をお願いします。NEX バージョンを変更する場合についても、各リージョンのパッチを同時にリリースする必要があります。\n",0]
,["Pages/Page_79041916.html","5. よくある質問",
"5. よくある質問\nここでは NEX を使用したタイトル開発時によくある質問についての回答を記載します。\n",0]
,["Pages/Page_79041916.html#PageId_79042118","5.1. 申請/サーバ準備",
"5.1. 申請/サーバ準備\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_ゲームサーバーの申請方法がわからない","ゲームサーバーの申請方法がわからない",
"ゲームサーバーの申請方法がわからない\nOMAS から申請を行います。OMAS へのログインには NDID が必要となります。NDID の発行については各窓口に確認してください。\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_申請したが、いつサーバーが使用できるようになるかわからない","申請したが、いつサーバーが使用できるようになるかわからない",
"申請したが、いつサーバーが使用できるようになるかわからない\nOMAS のフェーズがサーバー設置に進んでから 3 営業日以内にサーバーが設置されます。適切に設置されていない場合には OMAS の掲示板機能を使用して設置担当者にお問い合わせください。\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_用意されたサーバーに接続できない","用意されたサーバーに接続できない",
"用意されたサーバーに接続できない\nサンプルをサンプルデモサーバーに接続する設定で、実行に成功するかを確認してください。失敗する場合、ネットワーク設定やアカウント設定に誤りがある可能性があります。設定を見直してください。\nサンプルデモサーバーへの接続は正常だが、用意されたタイトルのサーバーへの接続がうまくいかない場合は「5.2. ログイン・共通機能」の「ゲームサーバーへのログインに必ず失敗する」を参考に設定を確認してください。\n",0]
,["Pages/Page_79041916.html#Anchor_79042118_今まで使用できていたサーバーに接続できなくなった","今まで使用できていたサーバーに接続できなくなった",
"今まで使用できていたサーバーに接続できなくなった\nゲームサーバーへのアクセスが一定期間（2 週間）なかった場合、ゲームサーバーは自動的に一時休止状態に落ちます。このとき、x06-0502（x はプラットフォームによって異なります）エラーが発生します。\n",0]
,["Pages/Page_79041916.html#PageId_79042341","5.2. ログイン・共通機能",
"5.2. ログイン・共通機能\n",0]
,["Pages/Page_79041916.html#Anchor_79042341_ゲームサーバーへのログインに必ず失敗する","ゲームサーバーへのログインに必ず失敗する",
"ゲームサーバーへのログインに必ず失敗する\nゲームサーバー ID とアクセスキーが間違っていないか確認してください。\nWii U の場合には、これに加えて、タイトル ID が適切に設定されているかを確認してください。\n",0]
,["Pages/Page_79041916.html#Anchor_79042341_ゲームサーバーへのログイン失敗時に、エラーコードX06-0801が表示される","ゲームサーバーへのログイン失敗時に、エラーコード X06-0801 が表示される",
"ゲームサーバーへのログイン失敗時に、エラーコード X06-0801 が表示される\nログイン失敗時のエラーハンドリングが適切ではない可能性があります。\nNgsFacade::Login() でログインに失敗した際、エラーコードを NgsFacade::GetLastLoginErrorCode() で正しく取得しているかどうかをご確認ください。\n",0]
,["Pages/Page_79050117.html","3. 開発時に注意が必要な項目",
"3. 開発時に注意が必要な項目\n",0]
,["Pages/Page_79050117.html#PageId_79051086","3.1. NEX 全般",
"3.1. NEX 全般\nここでは NEX 全般を使用する際に注意が必要な項目について記載します。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_初期化・ログイン","初期化・ログイン",
"初期化・ログイン\nゲームサーバーにログインするためには、NEX ライブラリ及びその他ライブラリの初期化が必要です。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_ログイン・ログアウト頻度","ログイン・ログアウト頻度",
"ログイン・ログアウト頻度\nログイン・ログアウト処理はサーバーにとって負荷の高い処理であるため、なるべく繰り返さない実装にしてください。例えば、オフラインのプレイで、ステージクリアごとにランキングをアップロードする仕様の場合、ステージクリアごとにログイン・ ログアウトを繰り返すような仕様は避けてください。一度ゲームサーバーにログインした後は、理由のない限りログイン状態を保持してください。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_非同期処理実行中のAC切断","非同期処理実行中の AC 切断",
"非同期処理実行中の AC 切断\nAC が切断された場合、NEX は正常に処理を続行できないため、NEX の終了処理を実行する必要がありますが、非同期処理実行中も同様です。非同期処理実行中に AC 切断を検知した場合には、非同期処理をキャンセルして NEX の終了処理を実行してください。非同期処理のキャンセルが難しい場合にはキャンセルを実施せずに終了処理を実施しても構いません。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_非同期処理のキャンセル","非同期処理のキャンセル",
"非同期処理のキャンセル\nNEX の非同期 API はすべてキャンセルすることが可能ですが、キャンセルしたタイミングによっては、サーバー上の処理が完了しているケースがあります。例えば、MatchmakeExtensionClient::CreateMatchmakeSession の非同期処理をキャンセルした場合、サーバー上ではマッチメイクセッションが作成されている可能性があります。マッチメイクセッションを参加可能な状態で作成している場合には無管理状態のマッチメイクセッションが作成されてしまう可能性がありますので、特別な理由がない限りは非同期処理でキャンセルを行わないことを推奨します。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_NEXのAPIをコールするスレッド","NEX の API をコールするスレッド",
"NEX の API をコールするスレッド\nスレッドモードとして推奨設定の ThreadModeUnsafeTransportBuffer を選択している場合、NEX のすべての API は同一スレッドからコールする必要があります。API が通信するかしないか、同期処理か非同期処理かに関わらず、同一のスレッドからコールしてください。もしくは適切に排他処理を行ってください。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_ゲームサーバーによって発行される各種IDの取り扱い","ゲームサーバーによって発行される各種 ID の取り扱い",
"ゲームサーバーによって発行される各種 ID の取り扱い\nゲームサーバーによって発行されるすべての ID には、ゲームサーバーを越えたユニーク性がありません。異なるタイトル間だけでなく、同じタイトルであっても、開発環境、ロットチェック環境、製品環境といったサーバー環境が違う場合にはユニーク性がありません。独自サーバーなどで管理する場合には注意が必要です。例えば、データストアのデータ ID は、ロットチェック環境と製品環境とで同一の ID になる可能性があるため、独自サーバーでデータ ID のみでデータを管理していると、重複する危険があります。ゲームサーバーによって発行される ID を独自サーバー等に保存する場合には、サービストークンに含まれる環境の情報と合わせて管理してください。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_NEXで扱う事の出来るデータ数","NEX で扱う事の出来るデータ数",
"NEX で扱う事の出来るデータ数\nNEX のランキング、マッチメイク、データストアで、それぞれ想定しているデータ数は 1000 万件程度です。これを越える場合、ユーザー体験に影響をあたえるレベルでのサーバパフォーマンスの低下の可能性があります。データストアの場合、ストレージサーバの使用、不使用を問わず、データの総数が 1000 万件となります。例えば、ユニークユーザー数が 10 万ユーザー想定の場合、各ユーザーが 100 個のデータをアップロードした場合、データの総数が 1000 万件になります。ランキングの場合、ユーザーは各カテゴリ毎に 1 件のデータのみ残すことができるため、ユニークユーザー数が 10 万ユーザー想定の場合、カテゴリが 100 個あった場合にデータの総数が 1000 万件になります。マッチメイクの場合、マッチメイクセッション数が 1000 万になることは通常無いと考えられますが、使用しなくなったマッチメイクセッションは順次クローズするようにしてください。\nデータの総数が 1000 万件を超える可能性がある場合には、事前に OMAS 掲示板等でご相談ください。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_サーバー設定の自動コピー","サーバー設定の自動コピー",
"サーバー設定の自動コピー\nNMAS によって設定したゲームサーバーの各種設定は、ロットチェック環境のサーバー設置時、製品環境のサーバー設置時にそれぞれコピーされます。従って、NMAS によりサーバー設定を変更する必要がある場合はロットチェック開始前に設定を完了しておいてください。サーバー設置後に開発環境と製品環境の設定を変更する必要がある場合には、NMAS より行ってください。ロットチェック環境のサーバー設置後に、ロットチェック環境の設定変更が必要な場合はロットチェック担当者へご連絡ください。\n",0]
,["Pages/Page_79050117.html#Anchor_79051086_NEXサーバーに接続するために必要な接続環境","NEX サーバーに接続するために必要な接続環境",
"NEX サーバーに接続するために必要な接続環境\nOMAS に表示されているサーバーの IP アドレスおよびポートを解放しただけでは NEX サーバーを使用することはできません。社内回線経由での接続など、制限された環境から接続しようとした場合、この IP アドレスおよびポートにアクセスできるようにしただけでは使用できませんので注意してください。必要なすべての IP アドレス一覧等は提供できませんので、制限のかかっていないネットワーク環境を準備してください。\n",0]
,["Pages/Page_79050117.html#PageId_79051174","3.2. ランキング",
"3.2. ランキング\nここではランキングを使用する際に注意が必要な項目について記載します。\n",0]
,["Pages/Page_79050117.html#Anchor_79051174_RankingConstants::ORDER_CALCULATION_123の動作","RankingConstants::ORDER_CALCULATION_123 の動作",
"RankingConstants::ORDER_CALCULATION_123 の動作\nRankingConstants::ORDER_CALCULATION_123 を指定している場合、同じスコアが複数ある場合には更新時刻が古い方が上位になります。また、同じスコアを登録した場合、更新日時がアップデートされるため、以前より順位が低くなる可能性があります。\nタイムスコープを RankingConstants::TIME_SCOPE_ALL もしくは、周期的にリセットされる期間での絞込みのみ使用している場合には、既に登録されているスコアと同スコアの場合にはスコアの登録を行わないようにすることで、順位の逆転を防ぐことができます。\nタイムスコープが、現在からの相対的な期間での絞込みに設定されている場合には、同スコアの場合であっても更新日時をアップデートする必要があるため、この方法は使用できません。この動作は仕様となります。\n",0]
,["Pages/Page_79050117.html#PageId_79051192","3.3. マッチメイク",
"3.3. マッチメイク\nここではマッチメイクを使用する際に注意が必要な項目について記載します。\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_マッチメイク選択条件としてMATCHMAKE_SELECTION_METHOD_SCORE_BASEDを使用する場合","マッチメイク選択条件として MATCHMAKE_SELECTION_METHOD_SCORE_BASED を使用する場合",
"マッチメイク選択条件として MATCHMAKE_SELECTION_METHOD_SCORE_BASED を使用する場合\nマッチメイクセッションの選択条件として MATCHMAKE_SELECTION_METHOD_SCORE_BASED を指定する場合で、マニュアルの「サーバーサービス」>「WebAPI」にある「スコア付けによるオートマッチメイク機能向け API」に例として記載してあるパラメータ以外の使い方を考えている場合には OMAS 掲示板等で任天堂にお問い合わせください。パラメーターの設定方法によっては意図した検索結果が得られない可能性があります。\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_マッチメイクセッションの空き部屋","マッチメイクセッションの空き部屋",
"マッチメイクセッションの空き部屋\n締め切っていないマッチメイクセッション（空き部屋）がサーバー上に大量に存在する場合、ゲームサーバーの検索負荷が増大し、ゲームサーバーのパフォーマン スが低下する可能性があります。アプリケーション上で募集を終了したマッチメイクセッションは必ずクローズするようにしてください。\nまた、オートマッチメイク機能を使用している場合には問題ありませんが、 MatchmakeExtensionClient::BrowseMatchmakeSession と MatchmakeExtensionClient::JoinMatchmakeSession を使用して、独自のマッチメイクを行っている場合には、検索条件によってはいつまでもマッチメイクが成立せず、サーバー上に大量の空き部屋が残り続ける可能性がありますので、見つからない場合には MATCHMAKE_SYSTEM_TYPE_ANYBODY を指定して検索した結果の部屋に入る等、空き部屋を埋めていく方向の仕様を検討してください\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_パスワード制限付きマッチメイクセッションの検索","パスワード制限付きマッチメイクセッションの検索",
"パスワード制限付きマッチメイクセッションの検索\n特定のユーザー同士でマッチメイクを行うために、マッチメイクセッションにパスワードを設定するケースがあります。このように、特定のユーザーのみ参加可能なマッチメイクセッションを検索結果に含めた場合、参加可能なマッチメイクセッションの数が少なくなる可能性があります。この結果ユーザーによるマッチメイクセッションの検索が繰り返され、ユーザー体験が低下したり、サーバー負荷が増大する危険性があります。従って MatchmakeExtensionClient::BrowseMatchmakeSession でマッチメイクセッションを検索する場合には、パスワード付きのマッチメイクセッションを除外して検索する設定を推奨します。\n",0]
,["Pages/Page_79050117.html#Anchor_79051192_オートマッチのマッチメイク条件が一つである場合の注意","オートマッチのマッチメイク条件が一つである場合の注意",
"オートマッチのマッチメイク条件が一つである場合の注意\nオートマッチを指定した時、マッチメイクの検索条件が一つのみの仕様である場合、同時接続ユーザー数が多い場合にサーバの負荷が増加する可能性があります。大量の同時接続が見込まれるタイトルの場合、ユーザーから見た検索条件は同じであっても、内部的に 2、3 種類にゲームモードを分ける等、分散させることを検討してください。企画上、同時接続数が多く分散も難しい場合には、弊社窓口まで問い合わせください。\n",0]
,["Pages/Page_79050117.html#PageId_79051194","3.4. データストア",
"3.4. データストア\nここではデータストアを使用する際に注意が必要な項目について記載します。\n",0]
,["Pages/Page_79050117.html#Anchor_79051194_データの検索条件","データの検索条件",
"データの検索条件\nデータストアのデータの検索時にアップロード時に指定したタグに一致するデータの検索が可能ですが、データ数に偏りが生じるようなタグ設定を行うとサーバーのパフォーマンスが低下する場合があります。例えば、\"jp\" や \"us\" など国のカテゴリを表すタグを設定した場合、利用されるタグが一部のものに集中してしまうため、それらのタグで検索を行うとデータベース上で参照するレコード数が増えて負荷が高まり、検索が重くなる場合があります。\nそのため、タグを利用する場合には一部のタグに利用が集中しないようにしてください。先の例のような国のカテゴリを設定したい場合には、データタイプを利用することを推奨します。\n",0]
,["Pages/Page_79061233.html","4. TIPS 集",
"4. TIPS 集\n",0]
,["Pages/Page_79061233.html#PageId_79061294","4.1. ランキング",
"4.1. ランキング\nここではランキング機能を使用する上での TIPS を紹介します。\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_多くのカテゴリでランキングを使用したい","多くのカテゴリでランキングを使用したい",
"多くのカテゴリでランキングを使用したい\nRankingClient::GetRanking() を使用する場合、同時に一つのカテゴリしか指定できません。多くのカテゴリを使用する場合にはカテゴリ数だけ API 呼び出しを行う必要があります。しかし、ランキングの API の呼び出し回数は 5 分 15 回の制限があるため、最大で 5 分間に 15 のカテゴリしか取得することができません。\nこのようなときには、制限付きですが、キャッシュつきランキングを使用することで対応が可能です。キャッシュつきランキング取得は RankingClient::GetCachedTopXRanking() を使用することで利用できます。 この API を使用すると TOP ランキングを複数カテゴリから合計 100 件まで取得することができます。例えば、Top 5 ランキングのみ必要であれば、 20 カテゴリのデータを取得することができます。\nまた、キャッシュつきランキングは、他のランキングの API と比較してアクセス頻度制限が緩められており、5 分間に 20 回の呼び出しが可能です。上記 Top 5 ランキングであれば、5 分間に 400 カテゴリ分のデータを取得することが可能です。\nキャッシュつきランキングを使用した場合、自分でスコアを登録しても、反映されるまで最大 5 分の時間がかかります。この場合ランキング登録直後に Top ランキングを取得しても自分のスコアが含まれていないランキングを取得することになります。このケースに対応するために、RankingCachedResult::LocalUpdate() を用意しています。この API に自分のランキングをセットすることで、自分のランキングをローカルでマージした状態のランキングを取得することができます。\nキャッシュつきランキングで取得できるカテゴリ数は NMAS を使用して設定します。クライアントから設定することはできません。\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_色々なランキングを高い頻度で使用したい","色々なランキングを高い頻度で使用したい",
"色々なランキングを高い頻度で使用したい\nRankingClient::GetCachedTopXRanking() を使用しても呼び出し頻度制限に収まらない場合や、Top ランキング以外のランキングを高い頻度で取得したい場合は、ランキング 2 の使用をご検討ください。\n ランキング 2 では、ランキングを取得する Ranking2Client::GetRanking() の呼び出し頻度制限が 1 分間に 20 回までとなっており、また、すべての API について呼び出し回数のカウントが独立となっています。\n ただし、ランキング 2 ではグループによるスコアの絞り込みが出来ないなど、ランキングとは仕様が異なる点がありますので、ご注意ください。\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_ランキングにたくさんのスコアを登録してデバッグをしたい","ランキングにたくさんのスコアを登録してデバッグをしたい",
"ランキングにたくさんのスコアを登録してデバッグをしたい\nランキング機能のデバッグ時には、ダミーデータを登録しての確認を強く推奨します。NEX のランキング API は一部、取得範囲に制限をかけており、ランキング数によって挙動が変わる可能性があります。具体的には、範囲ランキングの取得範囲を設定するためのオフセット値は、1000 未満の値にのみ対応しています。これ以上の値をオフセットとして指定すると、API の呼び出しがエラーになります。ダミーデータの登録を行うことにより、このようなランキング登録数によってフローが変わるようなケースの確認をすることができます。\nダミーデータの登録は、NMAS を使用することで利用できます。登録件数については、1500 件以上を推奨します。サーバ負荷に影響しますので、ダミーデータの総登録数は 100 万件までにしてください。また、ダミーデータ登録には時間がかかりますので、少ない件数から徐々に登録件数を増やしていくことを推奨します。\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_バージョンアップでランキングの互換を切りたい","バージョンアップでランキングの互換を切りたい",
"バージョンアップでランキングの互換を切りたい\nバージョンアップ前後でランキングの互換を切りたい場合、バージョンアップ前後でカテゴリを変更し、投稿先を変更することで対応する事を推奨します。\nバージョンアップ時の更新を必須とし、ランキングのデータをリセットすることも可能ですが、バージョンアップ版の配信時間と、サーバーのリセット時間、ユーザーをサーバーから一斉退出させる調整が必要になります。また、複数のリージョンでリリースしているタイトルについては、ゲームサーバーが共通になりますので、互換を切る場合、全世界同時にバージョンアップを行う必要があります。可能であればカテゴリの変更を行う事を推奨します。\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_リージョン毎にランキングを分けたい","リージョン毎にランキングを分けたい",
"リージョン毎にランキングを分けたい\nゲームサーバーをリージョン毎に分けることはできないため、リージョン毎にランキングを分けたい場合には、リージョン毎に別のカテゴリを使用するようにしてください。\n",0]
,["Pages/Page_79061233.html#Anchor_79061294_データストアと連携したい","データストアと連携したい",
"データストアと連携したい\nランキングにスコアを登録する際にユーザーに関するデータなどを含めたい場合には、そのデータをデータストアにアップロードし、ランキングのスコアと紐づける方法があります。\nあらかじめスコアを登録するユーザーはデータストアに必要なデータをアップロードしておき、そのデータのデータID を保管しておきます。そして、 RankingClient::UploadScore() を実行する際に、RankingScoreData オブジェクトのパラメータにデータストアのデータID をセットします。そうすることにより、ランキングを取得したユーザーはデータID を元にデータストアからデータをダウンロード出来ます。\n",0]
,["Pages/Page_79061233.html#PageId_80121852","4.2. マッチメイク",
"4.2. マッチメイク\nここではマッチメイク機能を使用する上での TIPS を紹介します。\n",0]
,["Pages/Page_79061233.html#Anchor_80121852_バージョンアップ時に、バージョンアップ前後のソフト同士でマッチメイクしないようにしたい","バージョンアップ時に、バージョンアップ前後のソフト同士でマッチメイクしないようにしたい",
"バージョンアップ時に、バージョンアップ前後のソフト同士でマッチメイクしないようにしたい\nバージョンアップ前後でマッチメイクの互換を切りたい場合、バージョンアップ前後でゲームモードを変更し、検索条件を変更することで対応する事を推奨します。\nバージョンアップ版配信後にすべてのユーザーがバージョンアップを行った状態でサーバーにアクセスするように設定することも可能ですが、バージョンアップ版の配信時間にあわせて、サーバーのリセットを行ったり、ユーザーをサーバーから一斉退出させる調整が必要になります。また、複数のリージョンでリリースしているタイトルについては、ゲームサーバーが共通になりますので、互換を切る場合、全世界同時にバージョンアップを行う必要があります。従って、ゲームモードの変更を行う事を推奨します。\nバージョンアップ時にゲームモードを変更していく運用を行った場合、ゲームモードの増加に伴いマッチメイク成功率が低下するというデメリットがあります。ユーザーが複数のゲームモードに分散してしまうことを防ぐため、過去バージョンからの認証を拒否する対応を行うことを推奨します。パッチの配信時にアカウントサーバーや認証サーバーに過去バージョンのアプリケーションからの認証を拒否する設定をいれることで、新規にゲームサーバーにログインするユーザーが最新のパッチを適用していることを保証できます。パッチが最新であることを保証する対応についての詳細はオーバービューのパッチの項目を参照してください。\n",0]
,["Pages/Page_79061233.html#PageId_80122292","4.3. データストア",
"4.3. データストア\nここではデータストア機能を使用する上での TIPS を紹介します。\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_データの保存場所を組み合わせて使用したい（ストレージサーバーとゲームサーバー）","データの保存場所を組み合わせて使用したい（ストレージサーバーとゲームサーバー）",
"データの保存場所を組み合わせて使用したい（ストレージサーバーとゲームサーバー）\nデータストア機能を使用してデータを保存する場合、ストレージサーバーに保存する方法と、ゲームサーバーに保存する方法があります。\nそれぞれのメリットとデメリットは以下の通りです。\n \t \tストレージサーバー \tゲームサーバー\n \tデータ 1 つあたりの容量 \t10 MByte \t1024 byte\n \t1 度にダウンロード、アップロードできるデータ数 \t1 件 \t100 件\n \tデータ ID 指定アップロード \tできない \tできる\n \t処理速度 \tゲームサーバーの場合と比べ時間がかかる \t-\n この 2 つを組み合わせて使用した場合、それぞれのメリットを生かすことができます。例えば、リプレイデータの本体をストレージサーバーに格納しておき、そのサムネイルをゲームサーバーの方に格納しておくことで、サムネイルだけ先にまとめて取得し、必要なデータをストレージサーバーから取得するという使い方も可能です。\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_カウンターとしてデータストアを使用したい","カウンターとしてデータストアを使用したい",
"カウンターとしてデータストアを使用したい\nデータストアのデータを評価することで、ゲーム参加者共有のカウンターとして使用する事が出来ます。\n例えば、あらかじめアップロードされたデータに対して、クライアントが評価を行い、評価値の合計を取得することで投票機能が実現できます。クライアントからの評価の範囲を、0 から 1 に、評価の置き換えを有効にしておくことで、クライアントあたり 1 票といった制限をかけたり、重複ロックをかけることにより、一定の期間につき 1 度だけ評価できるようにするといった仕様を実現可能です。\nゲーム全体のカウンターとして使用する場合には、誰かがデータをアップロードする必要があります。この場合、データ ID 指定アップロード機能を使用することで、決められた ID のデータがアップロードされていない場合にのみアップロードするという運用が可能になります。この場合、評価を実施してみて、データが存在しない場合にアップロードするという流れになります。\n評価値に負の値を設定することも可能ですので、ゲーム参加者のグローバルな変数として自由に使用することも可能です。\nただし、評価値に対する比較演算を行うことはできないため、特定の評価値以上のデータを絞り込むような使い方はできません。\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_ランダムなデータを取得したい","ランダムなデータを取得したい",
"ランダムなデータを取得したい\nアップロードしたデータをランダムに取得したい場合、取得するデータのオフセット値として RESULTRANGE_ANY_OFFSET を指定することで、サーバー側で疑似的にランダムに選択したデータを返却します。これにより、毎回同じデータが取得されるのを防ぐことができます。\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_バージョンアップで、データの互換性を切りたい","バージョンアップで、データの互換性を切りたい",
"バージョンアップで、データの互換性を切りたい\nバージョンアップ前後でデータストアの互換を切りたい場合、バージョンアップ前後でデータタイプを変更し、投稿先を変更することで対応する事を推奨します。\nバージョンアップ時の更新を必須とすることも可能ですが、バージョンアップ版の配信時間と、サーバーのリセット時間、ユーザーをサーバーから一斉退出させる調整が必要になります。また、複数のリージョンでリリースしているタイトルについては、ゲームサーバーが共通になりますので、互換を切る場合、全世界同時にバージョンアップを行う必要があります。可能であればデータタイプの変更を行う事を推奨します。\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_ネットワーク経由で疑似的なすれちがい通信を行いたい","ネットワーク経由で疑似的なすれちがい通信を行いたい",
"ネットワーク経由で疑似的なすれちがい通信を行いたい\nデータストアを使用して、疑似的なすれちがいを実施したい場合には、データタイプにより受信済み、未受信を管理することで、実現できます。例えば、すれちがいに使用したいデータをアップロードする際にはデータタイプを1として アップロードし、検索条件としてデータタイプが 1 の物を 1 件取得します。このデータを取得したユーザーはデータタイプを 0 にすることで、同じデータが取得されるのを防ぐことができ、また、アップロードしたユーザーは取得されたデータがどのデータであるかを後から把握することができます。\nタグによりデータのカテゴリを大きく分類して検索する方法も考えられますが、「3.4. データストア」にあるように NEX のデータストアは、このように大きな検索範囲からデータを検索する用途には向いていないため、データ総数が増えた場合にサーバ負荷が上昇し、サービスの劣化に繋がる可能性がありますので、避けてください。\n",0]
,["Pages/Page_79061233.html#Anchor_80122292_いつの間に通信との連携を行いたい","いつの間に通信との連携を行いたい",
"いつの間に通信との連携を行いたい\nいつの間に通信を利用して DataStore サーバーにデータのアップロード・ダウンロードが可能です。詳細は「プログラミングマニュアル - いつの間に通信編」を参照してください。\nまた、NEX のライブラリを利用して DataStore サーバーにデータをアップロードしておき、受信はいつの間に通信の機能を利用するなど組み合わせての利用も可能です。\n",0]
,["Pages/Page_92335117.html","6. 変更履歴",
"6. 変更履歴\n \t改訂日 \t分類 \t変更内容\n \t2015-08-20 \t- \t初版\n",0]
];
for (var x = 0; x < Search.additionalData.length; x++) Search.indexData.push(Search.additionalData[x]);
